/*
 * beaglefs/beaglefs.c - entry point for beaglefs
 *
 * Robert Love <rml@novell.com>
 *
 * Copyright (C) 2006 Robert Love
 *
 * Licensed under the terms of the GNU GPL v2
 */

#define FUSE_USE_VERSION 25
#include <fuse.h>

#include <glib.h>

#include "hit.h"
#include "file.h"

static int opt_process (void *data,
			const char *arg,
			int key,
			G_GNUC_UNUSED struct fuse_args *outargs)
{
	char **s = data;
	if (key == FUSE_OPT_KEY_NONOPT && !*s) {
		*s = g_strdup (arg);
		return 0;
	}

	return 1;
}

int
main (int argc, char *argv[])
{
	struct fuse_args args = FUSE_ARGS_INIT (argc, argv);
	char *query = NULL;

	g_log_set_always_fatal (G_LOG_LEVEL_CRITICAL | G_LOG_LEVEL_ERROR);

	if (fuse_opt_parse (&args, &query, NULL, opt_process) == -1 || !query)
		g_critical ("usage: %s <query> <mount point>", argv[0]);

	beagle_hit_set_query (query);

	return fuse_main (args.argc, args.argv, &beagle_file_ops);
}
